local list = {}

    function isEmpty(str)
        return str == nil or str == ""
    end

    function drawBox(color, text)
        Icon:color(color)
        local flipped = Block:get("Flipped")
        local direction = Block:get("Direction")
        local frame = Block:get("Frame")
        local xLeft = frame[1]
        local xTot = frame[3]
        local yUp = frame[2]
        local yTot = frame[4]
        local s1 = [[<b><i>]] .. string.sub(text,1,1) .. [[<i><b>]]
        local x, y, r
  
        if isEmpty(string.sub(text,1,1)) then
            x = 0
            y = 0
        else
            x = 16.9
            y = 8
        end
  
        -- radius for arc
        r = 10
  
        -- draw frame
        if direction == 0.0 then
            Icon:line({xLeft+xTot, xLeft+xTot}, {yUp+x, yUp+yTot-r})
            Icon:line({xLeft+r, xLeft+xTot-y}, {yUp, yUp})
        end
  
        if direction == 0.25 then
            Icon:line({xLeft+xTot, xLeft+xTot}, {yUp+yTot-r, yUp+y})
            Icon:line({xLeft+r, xLeft+xTot-x}, {yUp, yUp})
        end
      
        if direction == 0.5 then
            Icon:line({xLeft+xTot, xLeft+xTot}, {yUp+yTot-r, yUp+x})
            Icon:line({xLeft+r, xLeft+xTot-y}, {yUp, yUp})
        end
       
        if direction == 0.75 then
            Icon:line({xLeft+xTot, xLeft+xTot}, {yUp+yTot-r, yUp+y})
            Icon:line({xLeft+r, xLeft+xTot-x}, {yUp, yUp})
        end
        Icon:line({xLeft+xTot-r, xLeft+r}, {yUp+yTot, yUp+yTot})
        Icon:line({xLeft, xLeft}, {yUp+yTot-r, yUp+r})
        Icon:arc(xLeft+r,yUp+r,r,r,180,-90)
        Icon:arc(xLeft+xTot-r,yUp+yTot-r,r,r,270,90)
        Icon:arc(xLeft+r,yUp+yTot-r,r,r,180,90)
    end

    function drawDecoration(color, color2, text)
        Icon:color(color)
        local flipped = Block:get("Flipped")
        local direction = Block:get("Direction")
        local frame = Block:get("Frame")
        local xLeft = frame[1]
        local xTot = frame[3]
        local yUp = frame[2]
        local yTot = frame[4]
        local s1 = [[<b><i>]] .. string.sub(text,1,1) .. [[<i><b>]]
        local s2 = [[<b><i>]] .. string.sub(text,2,2) .. [[<i><b>]]
        local xT1, xT2, yT1, yT2, position, x1, y1, x2, y2

        if direction == 0.0 then
            x1 = xLeft+xTot-8
            x2 = xLeft+xTot
            y1 = yUp
            y2 = yUp+16.9
        
            if flipped then    
                xT1 = (x1+x2)/2
                yT1 = (y1+y2)/2-2.5
                xT2 = xT1
                yT2 = (y1+y2)/2+2.5
                else      
                xT1 = (x1+x2)/2
                yT1 = (y1+y2)/2+2.5
                xT2 = xT1
                yT2 = (y1+y2)/2-2.5
            end
        end

        if direction == 0.25 then
            x1 = xLeft+xTot
            x2 = xLeft+xTot-16.9
            y1 = yUp
            y2 = yUp+8
            
            xT1 = (x1+x2)/2+2.5
            yT1 = (y1+y2)/2
            xT2 = (x1+x2)/2-2.5
            yT2 = yT1
        end

        if direction == 0.5 then
            x1 = xLeft+xTot-8
            x2 = xLeft+xTot
            y1 = yUp
            y2 = yUp+16.9
            if flipped then      
                xT1 = (x1+x2)/2
                yT1 = (y1+y2)/2+2.5
                xT2 = xT1
                yT2 = (y1+y2)/2-2.5
            else
                xT1 = (x1+x2)/2
                yT1 = (y1+y2)/2-2.5
                xT2 = xT1
                yT2 = (y1+y2)/2+2.5
            end
        end

        if direction == 0.75 then
            x1 = xLeft+xTot-16.9
            x2 = xLeft+xTot
            y1 = yUp
            y2 = yUp+8
            
            xT1 = (x1+x2)/2-2.5
            yT1 = (y1+y2)/2
            xT2 = (x1+x2)/2+2.5
            yT2 = yT1
          end 
  
        -- draw box
        drawBox(color, text)
  
        if isEmpty(string.sub(text,1,1)) then
            local height = 35
            local width = 73.937
            local newHeight = 8
            local newWidth = width/(height/newHeight)

            -- get path to correct PNG
            local path
            if Preferences:get('Appearance') == 'dark' then
                path = './lua/vincotech_dark.png'
            else
                path = './lua/vincotech.png'
            end
       
            if direction == 0.75 then 
                if flipped then
                    Icon:image({(x1+x2)/2-newWidth/2, (x1+x2)/2+newWidth/2}, {y2, y1}, path, 'on')
                else
                    Icon:image({(x1+x2)/2-newWidth/2, (x1+x2)/2+newWidth/2}, {y1, y2}, path, 'on')
                end
            end
            
            if direction == 0.0 then
                if flipped then
                    Icon:image({(y1+y2)/2-newWidth/2, (y1+y2)/2+newWidth/2}, {x1, x2}, path, 'off')
                else
                    Icon:image({-(y1+y2)/2-newWidth/2, -(y1+y2)/2+newWidth/2}, {x1, x2}, path, 'off')
                end
            end
            
            if direction == 0.25 then
                if flipped then
                    Icon:image({(x1+x2)/2+newWidth/2, (x1+x2)/2-newWidth/2}, {y1, y2}, path, 'on')
                else
                    Icon:image({(x1+x2)/2+newWidth/2, (x1+x2)/2-newWidth/2}, {y2, y1}, path, 'on')
                end
            end
            
            if direction == 0.5 then
                if flipped then
                    Icon:image({-(y1+y2)/2-newWidth/2, -(y1+y2)/2+newWidth/2}, {-x2, -x1}, path, 'off')
                else
                    Icon:image({(y1+y2)/2-newWidth/2, (y1+y2)/2+newWidth/2}, {-x2, -x1}, path, 'off')
                end
            end
        else
            Icon:color(color)
            Icon:patch({x1, x2, x2, x1}, {y1, y1, y2, y2})
            if isEmpty(string.sub(text,2,2)) then
                Icon:text((x1+x2)/2, (y1+y2)/2, s1, 'FontSize', 8, 'TextFormat', 'RichText', 'Color', {color2})
            else
                Icon:text(xT1, yT1, s1, 'FontSize', 8, 'TextFormat', 'RichText', 'Color', {color2})
                Icon:text(xT2, yT2, s2, 'FontSize', 8, 'TextFormat', 'RichText', 'Color', {color2})
            end
        end
    end
        
    function drawDiode(x, y)
        Icon:line(Vector{0, 0}+x,
        Vector{-15, -6}+y)
        Icon:line(Vector{0, 0}+x,
        Vector{6, 15}+y)
        Icon:line(Vector{-7, 7}+x,
        Vector{-6, -6}+y)
        Icon:line(Vector{0, 7, -7, 0}+x,
        Vector{-6, 6, 6, -6}+y)
    end
    
    function drawDiodeH(x, y, flip)
        local mirror = 1
        if flip then
            mirror = -1
        end
        Icon:line(Vector{-15, -6}*mirror+x,
                Vector{0, 0}+y)
        Icon:line(Vector{6, 15}*mirror+x,
                Vector{0, 0}+y)
        Icon:line(Vector{-6, -6}*mirror+x,
                Vector{-7, 7}+y)
        Icon:line(Vector{-6, 6, 6, -6}*mirror+x,
                Vector{0, 7, -7, 0}+y)
    end

    function drawSwitch(x, y, symbol)
        Icon:line(Vector{0, 0}+x,
        Vector{-25, -10}+y)
        Icon:line(Vector{0, 0}+x,
        Vector{10, 25}+y)
        if symbol == "2" then
            Icon:line(Vector{0, -10}+x,
            Vector{-10, -10}+y)
            Icon:line(Vector{-10, 0}+x,
            Vector{10, 10}+y)
            Icon:line(Vector{-10, -10}+x,
            Vector{-13, -7}+y)
            Icon:line(Vector{-10, -10}+x,
            Vector{-3, 3}+y)
            Icon:line(Vector{-10, -10}+x,
            Vector{13, 7}+y)
            Icon:line(Vector{-15, -15}+x,
            Vector{10, -10}+y)
            Icon:line(Vector{-15, -20}+x,
            Vector{0, 0}+y)
            Icon:line(Vector{-10, 0, 0}+x,
            Vector{0, 0, 10}+y)
            Icon:line(Vector{-4, -8, -4}+x,
            Vector{2, 0, -2}+y)
        else
            Icon:line(Vector{0, -10}+x,
            Vector{-10, -4}+y)
            Icon:line(Vector{-10, 0}+x,
            Vector{4, 10}+y)
            Icon:line(Vector{-10, -10}+x,
            Vector{8, -8}+y)
            Icon:line(Vector{-14, -14}+x,
            Vector{8, -8}+y)
            Icon:line(Vector{-5.65, -1.667, -3.864}+x,
            Vector{8.634, 9, 5.658}+y)
            Icon:line(Vector{-14, -20}+x,
            Vector{0, 0}+y)
        end
        Icon:line(Vector{0, 10, 10}+x,
        Vector{-14, -14, -6}+y)
        Icon:line(Vector{10, 10, 0}+x,
        Vector{6, 14, 14}+y)
        Icon:line(Vector{3, 17}+x,
        Vector{-6, -6}+y)
        Icon:line(Vector{10, 17, 3, 10}+x,
        Vector{-6, 6, 6, -6}+y)
    end
        
    function drawSwitchH(x, y, symbol, flip)
        local mirror = 1
        if flip then
            mirror = -1
        end
        Icon:line(Vector{-25, -10}*mirror+x,
        Vector{0, 0}+y)
        Icon:line(Vector{10, 25}*mirror+x,
        Vector{0, 0}+y)
        if symbol == "2" then
            Icon:line(Vector{-10, -10}*mirror+x,
            Vector{0, -10}+y)
            Icon:line(Vector{10, 10}*mirror+x,
            Vector{-10, 0}+y)
            Icon:line(Vector{-13, -7}*mirror+x,
            Vector{-10, -10}+y)
            Icon:line(Vector{-3, 3}*mirror+x,
            Vector{-10, -10}+y)
            Icon:line(Vector{13, 7}*mirror+x,
            Vector{-10, -10}+y)
            Icon:line(Vector{10, -10}*mirror+x,
            Vector{-15, -15}+y)
            Icon:line(Vector{0, 0}*mirror+x,
            Vector{-15, -20}+y)
            Icon:line(Vector{0, 0, 10}*mirror+x,
            Vector{-10, 0, 0}+y)
            Icon:line(Vector{2, 0, -2}*mirror+x,
            Vector{-4, -8, -4}+y)
        else
            Icon:line(Vector{-10, -4}*mirror+x,
            Vector{0, -10}+y)
            Icon:line(Vector{4, 10}*mirror+x,
            Vector{-10, 0}+y)
            Icon:line(Vector{8, -8}*mirror+x,
            Vector{-10, -10}+y)
            Icon:line(Vector{8, -8}*mirror+x,
            Vector{-14, -14}+y)
            Icon:line(Vector{8.634, 9, 5.658}*mirror+x,
            Vector{-5.65, -1.667, -3.864}+y)
            Icon:line(Vector{0, 0}*mirror+x,
            Vector{-14, -20}+y)
        end
        Icon:line(Vector{-14, -14, -6}*mirror+x,
        Vector{0, 10, 10}+y)
        Icon:line(Vector{6, 14, 14}*mirror+x,
        Vector{10, 10, 0}+y)
        Icon:line(Vector{-6, -6}*mirror+x,
        Vector{3, 17}+y)
        Icon:line(Vector{-6, 6, 6, -6}*mirror+x,
        Vector{10, 17, 3, 10}+y)
    end
    
    function drawSwitchWoDiode(x, y, symbol)
        Icon:line(Vector{0, 0}+x,
        Vector{-25, -10}+y)
        Icon:line(Vector{0, 0}+x,
        Vector{10, 25}+y)
        if symbol == "2" then
            Icon:line(Vector{0, -10}+x,
            Vector{-10, -10}+y)
            Icon:line(Vector{-10, 0}+x,
            Vector{10, 10}+y)
            Icon:line(Vector{-10, -10}+x,
            Vector{-13, -7}+y)
            Icon:line(Vector{-10, -10}+x,
            Vector{-3, 3}+y)
            Icon:line(Vector{-10, -10}+x,
            Vector{13, 7}+y)
            Icon:line(Vector{-15, -15}+x,
            Vector{10, -10}+y)
            Icon:line(Vector{-15, -20}+x,
            Vector{0, 0}+y)
            Icon:line(Vector{-10, 0, 0}+x,
            Vector{0, 0, 10}+y)
            Icon:line(Vector{-4, -8, -4}+x,
            Vector{2, 0, -2}+y)
        else
            Icon:line(Vector{0, -10}+x,
            Vector{-10, -4}+y)
            Icon:line(Vector{-10, 0}+x,
            Vector{4, 10}+y)
            Icon:line(Vector{-10, -10}+x,
            Vector{8, -8}+y)
            Icon:line(Vector{-14, -14}+x,
            Vector{8, -8}+y)
            Icon:line(Vector{-5.65, -1.667, -3.864}+x,
            Vector{8.634, 9, 5.658}+y)
            Icon:line(Vector{-14, -20}+x,
            Vector{0, 0}+y)
        end
    end

return list
